%define basen gfan
%define major 0
%define libname %mklibname %{basen} %{major}
%define develname %mklibname %{basen} -d
Name:           gfan
Version:        0.6.2
Release:        %mkrel 1
Summary:        Software for Computing Gröbner Fans and Tropical Varieties
Group:		    Sciences/Mathematics
License:        GPLv2+
URL:            http://home.math.au.dk/jensen/software/gfan/gfan.html
Source0:        http://home.math.au.dk/jensen/software/%{name}/%{name}%{version}.tar.xz
Patch0:         %{name}-warning.patch
Patch1:         %{name}-permissive.patch
Patch2:         %{name}-shared.patch

BuildRequires:  cddlib-devel
BuildRequires:  gcc-c++
# BuildRequires:  ghostscript-tools-dvipdf
BuildRequires:  dvipdf
BuildRequires:  gmp-devel
BuildRequires:  texlive-texmf
BuildRequires:  TOPCOM
Requires:       %{libname} = %{version}-%{release}
Requires:       TOPCOM

%description
The software computes all marked reduced Gröbner bases of an ideal.
Their union is a universal Gröbner basis. Gfan contains algorithms for
computing this complex for general ideals and specialized algorithms
for tropical curves, tropical hypersurfaces and tropical varieties of
prime ideals. In addition to the above core functions the package
contains many tools which are useful in the study of Gröbner bases,
initial ideals and tropical geometry. Among these are an interactive
traversal program for Gröbner fans and programs for graphical renderings.

%package        doc
Summary:        Gfan examples and documentation files
Group:		    Documentation
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
Gfan examples and documentation files.

%package -n %{libname}
Summary:        Polyhedral computations related to polynomial rings
Group:		    System/Libraries

%description -n %{libname}
Gfanlib has two major features:
1) high-level exact polyhedral cone and polyhedral fan classes;
2) fast exact mixed volume computation for lattice polytopes with overflow
   checking.

In particular, gfanlib is missing the Gröbner basis part of gfan.

%package -n %{develname}
Summary:        Development files for libgfan
Group:		    Development/Libraries
Requires:       %{libname} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}
Requires:       gmp-devel

%description -n %{develname}
The libgfan-devel package contains libraries and header files for
developing applications that use libgfan.

%prep
%setup -q -n %{name}%{version}
%patch0
%patch1
%patch2

# Point to where the TOPCOM binaries will be installed
sed -i.orig "s|^\(#define MINKOWSKIPROGRAM \).*|\1\"%{_bindir}/essai\"|" \
  src/minkowskisum.cpp
touch -r src/minkowskisum.cpp.orig src/minkowskisum.cpp
rm -f src/minkowskisum.cpp.orig

# No need to install a simple upstream Makefile to rsync homepage
# directory to upstream page.
rm -f homepage/Makefile

%build
make %{?_smp_mflags} CC=gcc CXX=g++ \
  OPTFLAGS="%{optflags} -DGMPRATIONAL -I%{_includedir}/cddlib" \
  PREFIX=%{_prefix} \
  SOPLEX_LINKOPTIONS="-Wl,--as-needed $RPM_LD_FLAGS"

# Build the manual
pushd doc
latex manual.tex
bibtex manual
latex manual.tex
latex manual.tex
dvipdf manual.dvi manual.pdf
popd

%install
# Install the library
mkdir -p %{buildroot}%{_libdir}
cp -p src/libgfan.so.0.0.0 %{buildroot}%{_libdir}
ln -s libgfan.so.0.0.0 %{buildroot}%{_libdir}/libgfan.so.0
ln -s libgfan.so.0 %{buildroot}%{_libdir}/libgfan.so

# Install the headers
mkdir -p %{buildroot}%{_includedir}/gfanlib
cp -p src/gfanlib*.h %{buildroot}%{_includedir}/gfanlib

# Fix the headers
for fil in %{buildroot}%{_includedir}/gfanlib/*.h; do
  sed -i.orig 's,#include "\(.*\)",#include <\1>,' $fil
  touch -r $fil.orig $fil
  rm $fil.orig
done

# Install the binaries
export LD_LIBRARY_PATH=%{buildroot}%{_libdir}
make install PREFIX=%{buildroot}%{_prefix}
pushd %{buildroot}%{_bindir}
    ./%{name} installlinks
popd


%files
%{_bindir}/*

%files          doc
%doc examples
%doc homepage

%files -n %{libname}
%{_libdir}/*.so.*

%files -n %{develname}
%{_includedir}/gfanlib/
%{_libdir}/*.so


%changelog
* Mon Jan 07 2020 tex - 0.6.2-1pclos2020
- create
